#include <netinet/in.h>
#include <net/if.h>
#include <net/pfvar.h>

#include <stdio.h>
#include <string.h>
#include <stdbool.h>
#include <stdlib.h>
#include <err.h>
#include <netdb.h>
#include <unistd.h>
#include <arpa/inet.h>


int
main(int argc, char *argv[])
{
	struct pf_state_key_cmp key;
	FILE *inf;
	char *s;
	size_t len;

	if ((inf = fdopen(STDIN_FILENO, "r")) == NULL)
		err(1, "fdopen");

	bzero(&key, sizeof(key));
	key.af = 2;

	while ((s = fgetln(inf, &len)) != NULL) {
		char *proto, *ip1, *ip2, *port1, *port2, *dir;
		struct protoent *pe;
		bool ports;

		if (strncmp(s, "all ", sizeof("all ") - 1) != 0)
			errx(1, "no all keyword: %s", s);

		proto = s + sizeof("all ") - 1;
		ip1 = strchr(proto, ' ');
		*ip1++ = '\0';

		if ((pe = getprotobyname(proto)) == NULL)
			err(1, "getprotobyname %s", proto);

		key.proto = pe->p_proto;
		ports = (key.proto == IPPROTO_TCP ||
		    key.proto == IPPROTO_UDP ||
		    key.proto == IPPROTO_ICMP);

		if (ports) {
			port1 = strchr(ip1, ':');
			*port1++ = '\0';
			dir = strchr(port1, ' ');
		} else
			dir = strchr(ip1, ' ');
		*dir++ = '\0';
		if (*dir == '(')
			dir = strchr(dir, '-');
		ip2 = strchr(dir, ' ');
		*ip2++ = '\0';
		if (ports) {
			port2 = strchr(ip2, ':');
			*port2++ = '\0';
			s = strchr(port2, ' ');
		} else
			s = strchr(ip2, ' ');
		*s = '\0';

		if (inet_aton(ip1, &key.addr[0].v4) != 1)
			errx(1, "inet_aton(%s)", ip1);
		if (inet_aton(ip2, &key.addr[1].v4) != 1)
			errx(1, "inet_aton(%s)", ip2);

		if (ports) {
			key.port[0] = htons(atoi(port1));
			key.port[1] = htons(atoi(port2));
		} else
			key.port[0] = key.port[1] = 0;

		if (write(STDOUT_FILENO, &key, sizeof(key)) != sizeof(key))
			err(1, "write");
	}
}
